#from quant_api import Quant_api
import sys
import json
import importlib as im

def is_request_validated(data, ptype):
    para = { "dividend" : ["vendor_id", "pts"]}
    for parameter in para[ptype]:
        if not parameter in data.keys():
            return False
    return True


def dividend(data):
    default_return_msg = {}
    if not is_request_validated(data, "dividend"):
        default_return_msg.update({"errorCode":"2002", "errorMsg":"json format is incorrect."})
        return json.dumps(default_return_msg)

    result = quant_api.dividend(data["pts"])
    result.update(default_return_msg)
    #quant_api.show_debug_info()
    return json.dumps(result,indent=2, sort_keys=True, ensure_ascii=False)

def usage():
    print( '\n\tUsage: %s vender portfiolio_file [YYYYMMDD]' % sys.argv[0] )
    print( 
    '''
        vender = sample (for testing)
        portfiolio_file = 客戶持股詳情檔
        YYYYMMDD = 假設今日日期 Default: Today
    ''' )
    sys.exit()

_NOW__ = ''
if __name__ == '__main__':
    if len(sys.argv) >= 3 and len(sys.argv) <= 4:
        vender = sys.argv[1]
        data = json.load(open(sys.argv[2], encoding='utf-8'))
        if len(sys.argv) == 4:
            _NOW__=sys.argv[3]
    else:
        usage()
    
    mod = im.import_module('vender.'+ vender + "_quant_api")
    Quant_api = getattr(mod, "Quant_api")
    
    quant_api = Quant_api("test", "", "", now=_NOW__)
    print(dividend(data))
