﻿#!/usr/bin/env python3
# -*- coding: UTF-8 -*-
import json
import sys
import pandas as pd


def main(xls_path):
	xls = pd.ExcelFile(xls_path)
	if len(xls.sheet_names) <2:
		return
	
	
	for sheet_name in xls.sheet_names[1:]:
		df = xls.parse(sheet_name)
		tc = sheet_name.replace(' ', '_')


		portfolio = {}
		portfolio["vendor_id"] = "test"
		portfolio["sync"] = 1
		obj = {}
		portfolio["pts"]= [obj]

		obj['recomm_id'] = str(df.loc[0][2])
		obj['rp_id'] = df.loc[1][2]
		obj['pt_id'] = df.loc[2][2]
		obj['last_tx_date'] = df.loc[3][2]
		obj['last_recomm_date'] = df.loc[4][2]
		obj['create_date'] = df.loc[5][2]
		if str(df.loc[6][2]) != 'nan': obj['last_check_date'] = df.loc[6][2]   
		if str(df.loc[7][2]) != 'nan': obj['last_reb_date'] = df.loc[7][2] 
		#obj['note'] = str(df.loc[8][2])
		fas = []
		obj['fas'] = fas
		
		#for i in range(10, len(df.loc[1:])):
		for i in range(11, 20):
			try:
				#print(str(df.loc[i][2]))
				if str(df.loc[i][2]) == 'nan':
					print('len(portfolios) = ' + str(i))
					break

				fas.append( { 
						'fund_id': str(df.loc[i][2]),
						'weight': str(df.loc[i][3])
				})
			except:
				print('len(portfolios) = ' + str(i))
				break
	
		#print(json.dumps(portfolio))
		outf = tc+'_portfolio.json'
		print("create file: " + outf)
		with open(outf, 'w') as outfile:
			json.dump(portfolio, outfile)


		recomm  = {}
		rp = {}
		recomm['rps']  = [rp]
		rp['recomm_guid'] = str(df.loc[0][9])
		rp['rp_id'] = df.loc[1][9]
		rp['note'] = str(df.loc[8][8])
		rp['data_Date'] = str(df.loc[9][8])
		fws = []
		rp['fws'] = fws
		#for i in range(10, len(df.loc[1:])):
		for i in range(11, 21):
			try:
				#print(df.loc[i][8])
				if str(df.loc[i][8]) == 'nan':
					print('len(recomm) = ' + str(i))
					break
				fws.append( { 
						'fund_id': str(df.loc[i][8]),
						'weight': str(df.loc[i][9])
				})
			except:
				print('len(recomm) = ' + str(i))
				break

		outf = tc+'_recomm.json'
		print ( "create file: " + outf)
		with open(outf, 'w') as outfile:
			json.dump(recomm, outfile)

def usage():
	print("USAGE:\n\t", sys.argv[0], " XLS_PATH"  )
	
if __name__ == "__main__":
	if len(sys.argv) == 2 :
		xls_path = sys.argv[1]
		main(xls_path)
	else:
		usage()
	
